import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { NotifierContainerComponent } from './components/notifier-container.component';
import { NotifierNotificationComponent } from './components/notifier-notification.component';
import { NotifierConfig } from './models/notifier-config.model';
import { NotifierAnimationService } from './services/notifier-animation.service';
import { NotifierQueueService } from './services/notifier-queue.service';
import { NotifierService } from './services/notifier.service';
/**
 * Notifier module
 */
export var NotifierModule = (function () {
    function NotifierModule() {
    }
    /**
     * Setup custom module (service) configuration
     */
    NotifierModule.forRoot = function (options) {
        return {
            ngModule: NotifierModule,
            providers: [
                {
                    provide: NotifierConfig,
                    useValue: new NotifierConfig(options)
                }
            ]
        };
    };
    NotifierModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        NotifierContainerComponent,
                        NotifierNotificationComponent
                    ],
                    exports: [
                        NotifierContainerComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    providers: [
                        NotifierAnimationService,
                        NotifierService,
                        NotifierQueueService
                    ]
                },] },
    ];
    /** @nocollapse */
    NotifierModule.ctorParameters = function () { return []; };
    return NotifierModule;
}());
//# sourceMappingURL=notifier.module.js.map